* [bug#56612] [PATCH] guix install: Add '--manifest' option.
@ 2022-07-17 10:20 Ludovic Courtès
2022-07-19 10:01 ` Liliana Marie Prikler
0 siblings, 1 reply; 5+ messages in thread
From: Ludovic Courtès @ 2022-07-17 10:20 UTC (permalink / raw)
To: 56612; +Cc: Ludovic Courtès
* guix/scripts/install.scm (show-help, %options): Add "--manifest".
* tests/guix-package-aliases.sh" Test "guix install -m".
---
guix/scripts/install.scm | 8 ++++++--
tests/guix-package-aliases.sh | 16 +++++++++++++---
2 files changed, 19 insertions(+), 5 deletions(-)
Hi!
I think it’s convenient and quite natural to be able to type:
guix install -m manifest.scm
Hence this patch. Objections? :-)
Thanks,
Ludo’.
diff --git a/guix/scripts/install.scm b/guix/scripts/install.scm
index 63e625f266..0d24d7c956 100644
--- a/guix/scripts/install.scm
+++ b/guix/scripts/install.scm
@@ -1,5 +1,5 @@
;;; GNU Guix --- Functional package management for GNU
-;;; Copyright © 2019, 2020 Ludovic Courtès <ludo@gnu.org>
+;;; Copyright © 2019, 2020, 2022 Ludovic Courtès <ludo@gnu.org>
;;;
;;; This file is part of GNU Guix.
;;;
@@ -33,6 +33,9 @@ (define (show-help)
This is an alias for 'guix package -i'.\n"))
(display (G_ "
-p, --profile=PROFILE use PROFILE instead of the user's default profile"))
+ (display (G_ "
+ -m, --manifest=FILE create a new profile generation with the manifest
+ from FILE"))
;; '--bootstrap' not shown here.
(display (G_ "
-v, --verbosity=LEVEL use the given verbosity LEVEL"))
@@ -61,7 +64,8 @@ (define %options
;; Preserve some of the 'guix package' options.
(append (filter (lambda (option)
(any (cut member <> (option-names option))
- '("profile" "dry-run" "verbosity" "bootstrap")))
+ '("profile" "dry-run" "verbosity" "bootstrap"
+ "manifest")))
%package-options)
%transformation-options
diff --git a/tests/guix-package-aliases.sh b/tests/guix-package-aliases.sh
index 311838b768..99cb9176cd 100644
--- a/tests/guix-package-aliases.sh
+++ b/tests/guix-package-aliases.sh
@@ -1,5 +1,5 @@
# GNU Guix --- Functional package management for GNU
-# Copyright © 2019, 2020 Ludovic Courtès <ludo@gnu.org>
+# Copyright © 2019, 2020, 2022 Ludovic Courtès <ludo@gnu.org>
#
# This file is part of GNU Guix.
#
@@ -28,9 +28,10 @@ readlink_base ()
}
profile="t-profile-$$"
-rm -f "$profile"
+manifest="t-manifest-$$"
+rm -f "$profile" "$manifest"
-trap 'rm -f "$profile" "$profile-"[0-9]*' EXIT
+trap 'rm -f "$profile" "$profile-"[0-9]* "$manifest"' EXIT
guix install --bootstrap guile-bootstrap -p "$profile"
test -x "$profile/bin/guile"
@@ -55,6 +56,15 @@ guix remove --bootstrap guile-bootstrap -p "$profile"
! test -x "$profile/bin/guile"
test `guix package -p "$profile" -I | wc -l` -eq 0
+# Installing from a manifest.
+cat > "$manifest" <<EOF
+(specifications->manifest '("guile-bootstrap"))
+EOF
+guix install -p "$profile" -m "$manifest" --bootstrap
+test -x "$profile/bin/guile"
+guix remove --bootstrap guile-bootstrap -p "$profile"
+! test -x "$profile/bin/guile"
+
! guix remove -p "$profile" this-is-not-installed --bootstrap
! guix remove -i guile-bootstrap -p "$profile" --bootstrap
--
2.36.1
^ permalink raw reply related [flat|nested] 5+ messages in thread
* [bug#56612] [PATCH] guix install: Add '--manifest' option.
2022-07-17 10:20 [bug#56612] [PATCH] guix install: Add '--manifest' option Ludovic Courtès
@ 2022-07-19 10:01 ` Liliana Marie Prikler
2022-07-21 9:09 ` Ludovic Courtès
0 siblings, 1 reply; 5+ messages in thread
From: Liliana Marie Prikler @ 2022-07-19 10:01 UTC (permalink / raw)
To: Ludovic Courtès, 56612
Am Sonntag, dem 17.07.2022 um 12:20 +0200 schrieb Ludovic Courtès:
> * guix/scripts/install.scm (show-help, %options): Add "--manifest".
> * tests/guix-package-aliases.sh" Test "guix install -m".
> ---
> guix/scripts/install.scm | 8 ++++++--
> tests/guix-package-aliases.sh | 16 +++++++++++++---
> 2 files changed, 19 insertions(+), 5 deletions(-)
>
> Hi!
>
> I think it’s convenient and quite natural to be able to type:
>
> guix install -m manifest.scm
>
> Hence this patch. Objections? :-)
I think the semantics of `guix install -m' are somewhat unclear. It
can mean both "add all of manifest to what I already have installed"
and "use manifest exactly as the manifest". The latter is equivalent
to `guix package -m' (which has clearer semantics here) and also the
implementation chosen IIUC. Personally, I don't think I'd want
"install" to remove packages.
Cheers
^ permalink raw reply [flat|nested] 5+ messages in thread
* [bug#56612] [PATCH] guix install: Add '--manifest' option.
2022-07-19 10:01 ` Liliana Marie Prikler
@ 2022-07-21 9:09 ` Ludovic Courtès
2022-07-21 10:37 ` Tobias Geerinckx-Rice via Guix-patches via
0 siblings, 1 reply; 5+ messages in thread
From: Ludovic Courtès @ 2022-07-21 9:09 UTC (permalink / raw)
To: Liliana Marie Prikler; +Cc: 56612
Hi,
Liliana Marie Prikler <liliana.prikler@ist.tugraz.at> skribis:
> Am Sonntag, dem 17.07.2022 um 12:20 +0200 schrieb Ludovic Courtès:
>> * guix/scripts/install.scm (show-help, %options): Add "--manifest".
>> * tests/guix-package-aliases.sh" Test "guix install -m".
>> ---
>> guix/scripts/install.scm | 8 ++++++--
>> tests/guix-package-aliases.sh | 16 +++++++++++++---
>> 2 files changed, 19 insertions(+), 5 deletions(-)
>>
>> Hi!
>>
>> I think it’s convenient and quite natural to be able to type:
>>
>> guix install -m manifest.scm
>>
>> Hence this patch. Objections? :-)
> I think the semantics of `guix install -m' are somewhat unclear. It
> can mean both "add all of manifest to what I already have installed"
> and "use manifest exactly as the manifest". The latter is equivalent
> to `guix package -m' (which has clearer semantics here) and also the
> implementation chosen IIUC. Personally, I don't think I'd want
> "install" to remove packages.
Right. To me, ‘-m’ is always declarative: you get what the manifest
prescribes, nothing else; this is how it’s currently documented.
Do you think it could be interpreted as “add all of manifest to what I
already have installed”?
Ludo’.
^ permalink raw reply [flat|nested] 5+ messages in thread
* [bug#56612] [PATCH] guix install: Add '--manifest' option.
2022-07-21 9:09 ` Ludovic Courtès
@ 2022-07-21 10:37 ` Tobias Geerinckx-Rice via Guix-patches via
2022-07-22 20:58 ` Ludovic Courtès
0 siblings, 1 reply; 5+ messages in thread
From: Tobias Geerinckx-Rice via Guix-patches via @ 2022-07-21 10:37 UTC (permalink / raw)
To: Ludovic Courtès; +Cc: liliana.prikler, 56612
[-- Attachment #1: Type: text/plain, Size: 318 bytes --]
Ludovic Courtès 写道:
> Do you think it could be interpreted as “add all of manifest to
> what I
> already have installed”?
It can; I did. I was going to raise the same objection as
Liliana. ‘guix package -m’ does not have this problem, ‘guix
install -m’ does.
Kind regards,
T G-R
[-- Attachment #2: signature.asc --]
[-- Type: application/pgp-signature, Size: 247 bytes --]
^ permalink raw reply [flat|nested] 5+ messages in thread
* [bug#56612] [PATCH] guix install: Add '--manifest' option.
2022-07-21 10:37 ` Tobias Geerinckx-Rice via Guix-patches via
@ 2022-07-22 20:58 ` Ludovic Courtès
0 siblings, 0 replies; 5+ messages in thread
From: Ludovic Courtès @ 2022-07-22 20:58 UTC (permalink / raw)
To: Tobias Geerinckx-Rice; +Cc: liliana.prikler, 56612
Tobias Geerinckx-Rice <me@tobias.gr> skribis:
> Ludovic Courtès 写道:
>> Do you think it could be interpreted as “add all of manifest to what
>> I
>> already have installed”?
>
> It can; I did. I was going to raise the same objection as Liliana.
> ‘guix package -m’ does not have this problem, ‘guix install -m’ does.
OK, interesting. I guess we can drop the idea then.
Thanks for your feedback!
Ludo’.
^ permalink raw reply [flat|nested] 5+ messages in thread
end of thread, other threads:[~2022-07-22 21:00 UTC | newest]
Thread overview: 5+ messages (download: mbox.gz follow: Atom feed
-- links below jump to the message on this page --
2022-07-17 10:20 [bug#56612] [PATCH] guix install: Add '--manifest' option Ludovic Courtès
2022-07-19 10:01 ` Liliana Marie Prikler
2022-07-21 9:09 ` Ludovic Courtès
2022-07-21 10:37 ` Tobias Geerinckx-Rice via Guix-patches via
2022-07-22 20:58 ` Ludovic Courtès
Code repositories for project(s) associated with this public inbox
https://git.savannah.gnu.org/cgit/guix.git
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).